# Map --
#
#   map of paccraft

inherit Map Control
method Map constructor {parent frame board} {
	MapA ${objName}_abst $objName $board
	this inherited $parent ${objName}_abst
	
	MapView ${objName}_detail $objName DetailP $frame [$this(abstraction) board]
}

method Map destructor {} {
	this inherited
}


# MapA --
#
#   map abstraction

inherit MapA Abstraction
method MapA constructor {control board} {
	set this(board) $board
	# position de la vue ...
}

method MapA board {} {
	return [$this(board) attribute abstraction]
}


# MapView --
#
#   generic map view (handle multiple presentations)

inherit MapView Control
method MapView constructor {parent PresentationClass frame board} {
	$PresentationClass ${objName}_pres $objName $frame $board
	this inherited $parent "" ${objName}_pres
}

method MapView destructor {} {
	this inherited
}


# DetailP --
#
#   detail on the map presentation

inherit DetailP Presentation
method DetailP constructor {control frame board} {
	this inherited $control
	set this(canvas) [canvas $frame.c -scrollregion {0 0 1500 1500} -bg green]
	pack $this(canvas) -fill both -expand yes
	
	global $board
	foreach {position unit} [array get $board "*,*"] {
		UnitP ${unit}_pres $unit $this(canvas)
		$unit setAttribute presentation ${unit}_pres
	}
}

method BoardP destructor {} {
	destroy $this(canvas)
}


# OverviewP --
#
#   overview presentation

inherit OverviewP Presentation
